int ExitCallback()
{
	S9xSetSoundMute( TRUE );
	g_bLoop = false;
	g_bSleep = true;
	if (g_bROMLoaded) {
		save_config();
		Memory.SaveSRAM( S9xGetFilename("srm") );
	}

	if ( g_thread !=-1 ){
		Settings.ThreadSound = FALSE;
		sceKernelWaitThreadEnd( g_thread, NULL );
		sceKernelDeleteThread( g_thread );
	}

	S9xCloseSoundDevice();

	scePowerSetClockFrequency(222,222,111);

	sceKernelExitGame();

	return 0;
}

void PowerCallback(int unknown, int pwrflags)
{

	if (pwrflags & POWER_CB_POWER) {
		if (g_bROMLoaded) {
			scePowerSetClockFrequency(222,222,111);
			S9xSetSoundMute( TRUE );
			g_bSleep = true;
			save_config();
			Memory.SaveSRAM( S9xGetFilename("srm") );
		}
	} else if (pwrflags & POWER_CB_RESCOMP) {
		g_bSleep = false;
	}

	if (pwrflags & POWER_CB_BATLOW) {
//		scePowerSetClockFrequency(222,222,111);
		S9xSetInfoString( "PSP̃obe[㏭ł" );
	}

	int cbid = sceKernelCreateCallback("Power Callback", (void *)PowerCallback);
	sceKernelRegisterPowerCallback(0, cbid);
}

int CallbackThread(int args, void *argp)
{
	int cbid;
	
	cbid = sceKernelCreateCallback("Exit Callback", (void*)ExitCallback);
	sceKernelRegisterExitCallback(cbid);
	cbid = sceKernelCreateCallback("Power Callback", (void*)PowerCallback);
	sceKernelRegisterPowerCallback(0, cbid);
	
	sceKernelSleepThreadCB();
}

int SetupCallbacks()
{
	int thid = 0;
	
	thid = sceKernelCreateThread("update_thread", (threadfunc_t)CallbackThread, 0x11, 0xFA0, 0, 0);
	if (thid >= 0) {
		sceKernelStartThread(thid, 0, 0);
	}
	
	return thid;
}

